<?php
if ( !defined('AREA') ) { die('Access denied'); }

if (defined('PAYMENT_NOTIFICATION')) {

	if($mode == 'result')
	{
		function ob_exit($status = null)
		{
			if($status) {
				ob_end_flush();
				isset($_REQUEST['debug']) ? exit($status) : exit();
			}
			else {
				ob_end_clean();
				header("HTTP/1.0 200 OK");
				echo "OK";
				exit();
			}
		}

		function debug_file()
		{
			header('Content-type: text/plain; charset=utf-8');
			echo file_get_contents(__FILE__);
		}

		function check_im()
		{
			$iplist = gethostbynamel('www.intellectmoney.ru');
			foreach($iplist as $ip)
				if(preg_match("/^$ip/", (isset($_SERVER['HTTP_REFERER']))?$_SERVER['HTTP_REFERER']:''))
					return true;
			return false;
		}
		
		function from_request($name)
		{
			return isset($_REQUEST[$name]) ? htmlspecialchars(stripslashes($_REQUEST[$name])) : null;
		}

		/*main check*/
		if(isset($_REQUEST['debug_file'])) {
			debug_file();
			exit;
		}
		ob_start();

		$eshopId = from_request('eshopId');
		$orderId = from_request('orderId');
		$serviceName = from_request('serviceName');
		$eshopAccount = from_request('eshopAccount');
		$recipientAmount = from_request('recipientAmount');
		$recipientCurrency = from_request('recipientCurrency');
		$paymentStatus = from_request('paymentStatus');
		$userName = from_request('userName');
		$userEmail = from_request('userEmail');
		$paymentData = from_request('paymentData');
		$secretKey = from_request('secretKey');
		$hash = from_request('hash');
		
		if(!isset($_REQUEST['orderId']) ) {
			ob_exit("ERROR: EMPTY REQUEST!\n");
		}
		
		$order_info = fn_get_order_info($orderId);
		$processor_data = fn_get_payment_method_data($order_info['payment_id']);
		
		$to_pay = im_get_price($order_info['total'],$processor_data['params']['im_test_live_mode']);
		
		// ORDER ID CHECK
		if(!$order_info || !is_array($to_pay)) {
			ob_exit("ERROR: ORDER NOT EXISTS OR TO_PAY EOF!\n");
		}
		
		$get_orderid = $order_info['order_id'];
		$get_amount = $to_pay[0];
		$get_currency = $to_pay[1];
		$get_eshopid = $processor_data['params']['im_ehopid'];
		$get_secret_key = $processor_data['params']['im_secretkey'];

		// AMOUNT and CURRENCY CODE CHECK
		if($recipientAmount != $get_amount || strtolower($recipientCurrency) != strtolower($get_currency)) {
			$err = "ERROR: AMOUNT/CURRENCY MISMATCH!\n";
			$err .= "recipientAmount: $recipientAmount; amount: $get_amount;\nrecipientCurrency: $recipientCurrency; currency: $get_currency;\n\n";
			ob_exit($err);
		}
		
		//   , 
		if($secretKey)
		{
			//    (  )
			if ($secretKey != $get_secret_key) {
				$err = "ERROR: SECRET_KEY MISMATCH!\n";
				$err .= check_im() ? ("secretKey: $secretKey; IM_SECRET_KEY: $get_secret_key;\n\n") : "\n";
				ob_exit($err);
			}
			
			//    
			if ($eshopId != $get_eshopid) {
				$err = "ERROR: INCORRECT ESHOP_ID!\n";
				$err .= "eshopId: $eshopId; IM_ESHOP_ID: $get_eshopid;\n\n";
				ob_exit($err);
			}
		}
		//  
		else
		{
			$control_hash_str = implode('::', array(
				$get_eshopid,
				$get_orderid,
				$serviceName, $eshopAccount, $recipientAmount, $recipientCurrency,
				$paymentStatus, $userName, $userEmail, $paymentData,
				$get_secret_key,
			));
			$control_hash = md5($control_hash_str);
			$control_hash_utf8 = md5(iconv('windows-1251', 'utf-8', $control_hash_str));
			
			if (($hash != $control_hash && $hash != $control_hash_utf8) || !$hash) {
				$err = "ERROR: HASH MISMATCH\n";
				$err .= check_im() ? "Control hash string: $control_hash_str;\n" : "";
				$err .= "Control hash win-1251: $control_hash;\nControl hash utf-8: $control_hash_utf8;\nhash: $hash;\n\n";
				ob_exit($err);
			}
		}
		
		if(from_request('paymentStatus') == 3) {
			$pp_response = array();
			$pp_response['order_status'] = 'P';
			$pp_response['reason_text'] = date('m.d.Y H:i:s');
			fn_update_order_payment_info($orderId, $pp_response);
			fn_change_order_status($orderId, $pp_response['order_status']);
			fn_finish_payment($orderId, $pp_response);
			ob_exit();
		}
		if(from_request('paymentStatus') == 5) {
			$pp_response = array();
			$pp_response['order_status'] = 'C';
			$pp_response['reason_text'] = date('m.d.Y H:i:s');
			fn_update_order_payment_info($orderId, $pp_response);
			fn_change_order_status($orderId, $pp_response['order_status']);
			fn_finish_payment($orderId, $pp_response);
			ob_exit();
		}
		
		ob_exit("ERROR: UNKNOWN PAYMENT STATUS!\n\n");		
		
	}
	elseif ($mode == 'unsupported_currency') {
		
		if (fn_check_payment_script('intellectmoney.php', $_REQUEST['order_id'])) {
			$pp_response = array();
			$pp_response['order_status'] = 'F';
			$pp_response['reason_text'] = fn_get_lang_var('im_text_unsupported_currency');
	
			fn_finish_payment($_REQUEST['order_id'], $pp_response);
			fn_order_placement_routines($_REQUEST['order_id']);
		}
	}
} else {

	$current_location = Registry::get('config.current_location');

	$url = 'https://merchant.intellectmoney.ru/ru/';
	$to_pay = im_get_price($order_info['total'],$processor_data['params']['im_test_live_mode']);
	//print_r($order_info);die;
	if (!isset($to_pay) || !is_array($to_pay)) {
		fn_set_notification('E', fn_get_lang_var('error'), fn_get_lang_var('im_text_unsupported_currency'));
		fn_redirect(Registry::get('config.current_location') . "/$index_script?dispatch=payment_notification.unsupported_currency&payment=intellectmoney&order_id=$order_id");
		exit;
	}
	
	$eshop_id = $processor_data['params']['im_ehopid'];
	$item_name = $processor_data['params']['im_order_prefix'].$order_id;
	$item_amount = $to_pay[0];
	$currency_code = $to_pay[1];
	$result = "$current_location/$index_script?dispatch=payment_notification.result&payment=intellectmoney";
	$success = "$current_location/$index_script?dispatch=payment_notification.success&payment=intellectmoney";
	$fail = "$current_location/$index_script?dispatch=payment_notification.fail&payment=intellectmoney";
	
	$control_hash = $eshop_id."::".$order_id."::".$item_name."::".$item_amount."::".$currency_code.'::'.$processor_data['params']['im_secretkey'];
	$hash = md5($control_hash);	

echo <<<EOT
<html>
<body onLoad="javascript: document.process.submit();">

<form id="process" action="https://merchant.intellectmoney.ru/ru/" name="process" method="post">
	<input type="hidden" name="eshopId" value="{$eshop_id}">
	<input type="hidden" name="orderId" value="{$order_id}">
	<input type="hidden" name="serviceName" value="{$item_name}">
	<input type="hidden" name="recipientAmount" value="{$item_amount}">
	<input type="hidden" name="email" value="{$order_info['email']}">
	<input type="hidden" name="username" value="{$order_info['s_firstname']} {$order_info['s_lastname']}">
	<input type="hidden" name="recipientCurrency" value="{$currency_code}">
	<input type="hidden" name="hash" value="{$hash}">
	<input type="hidden" name="resultUrl" value="{$result}" />
	<input type="hidden" name="successUrl" value="{$success}">
	<input type="hidden" name="failUrl" value="{$fail}">
EOT;
$msg = fn_get_lang_var('text_cc_processor_connection');
$msg = str_replace('[processor]', 'IntellectMoney', $msg);
echo <<<EOT
	</form>
   <p><div align=center>{$msg}</div></p>
 </body>
</html>
EOT;
exit;
}

function im_get_price($price,$im_test_live_mode)
{
	$currencies = Registry::get('currencies');
	if (empty($currencies['RUB']) && empty($currencies['TST'])) {
		return false;
	}
	$rub = false;
	$tst = false;
	if(isset($currencies['RUB']['is_primary']) && $currencies['RUB']['is_primary'] == 'Y' && !$im_test_live_mode) $rub = true;
	if(isset($currencies['TST']['is_primary']) && $currencies['TST']['is_primary'] == 'Y' && $im_test_live_mode) $tst = true;
	if(!$rub && !$tst) {
		return false;
	}	
	if(empty($currencies[!$im_test_live_mode ? 'RUB' : 'TST']['coefficient']))return false;
	return array(fn_format_price($price / $currencies[!$im_test_live_mode ? 'RUB' : 'TST']['coefficient']), $rub ? 'RUB' : 'TST');
}

?>